unit u27_u1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, StdCtrls;

type
  TFces=record       //definice typ
    cesta:string;
    delka:real;
  end;
  TOpt=record         //nastaven
    pol:integer;
    c1,c2:Tcolor;
    nazvy,cesty:boolean;
  end;
  TMesto=record
    nazev:string;
    poloha:TPoint;
  end;
  TCesta=record
    z,doo:string;
    prumernaRychlost,vzdalenost:real;
  end;
  TSpotreba=record
    rychlost,litru:real;
  end;
  TMapa=record
    mesta:array of TMesto;
    cesty:array of TCesta;
    spotreby:array of TSpotreba;
  end;
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    Uloit1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Shape1: TShape;
    Label1: TLabel;
    Shape2: TShape;
    Label2: TLabel;
    Shape3: TShape;
    Label3: TLabel;
    Label4: TLabel;
    Bevel1: TBevel;
    Memo1: TMemo;
    Label5: TLabel;
    Bevel2: TBevel;
    Label6: TLabel;
    ComboBox1: TComboBox;
    Label7: TLabel;
    ComboBox2: TComboBox;
    Label8: TLabel;
    Label9: TLabel;
    ComboBox3: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    Memo2: TMemo;
    SaveDialog1: TSaveDialog;
    Label12: TLabel;
    procedure Konec1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Uloit1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    ces:string;              //spravna nalezena cesta
    index:array of TPoint;  //souradnice mest na obrazovce
    fces:Array of TFces;      //nalezene cesty
    mapa:TMapa;         //nactena data
    opt:TOpt;
    procedure draw;   //vykresleni
  end;

var
  Form1: TForm1;

implementation

uses Types;

{$R *.dfm}

procedure TForm1.Konec1Click(Sender: TObject);
begin
  close;
end;



procedure TForm1.Otevt1Click(Sender: TObject);
var
t:textfile;                     //nacteni souboru
partag,tag,a:string;
i,j:integer;
procedure myreadln(var st:string);
begin
  repeat
    readln(t,st);
    while pos(' ',st)=1 do delete(st,1,1);
  until st<>'';
end;

begin
  ces:='';
  mapa.mesta:=nil;
  mapa.cesty:=nil;
  mapa.spotreby:=nil;
  combobox1.Items.Clear;
  combobox2.Items.Clear;
  if opendialog1.Execute then begin
    if fileexists(opendialog1.Filename) then begin
      assignfile(t,opendialog1.Filename);
      reset(t);
      partag:='';
      while not eof(t) do begin
        myreadln(a);
        while pos('<',a)>0 do begin
          i:=pos('<',a);
          tag:='';
          for j:=i to length(a) do begin
            tag:=tag+a[j];
            if a[j]='>' then break;
          end;
          delete(a,i,length(tag));
        end;
        if (length(tag)<2) or (tag[2]<>'/') then begin
          if (length(tag)>1) and (tag[2]<>'?') then partag:=partag+' '+tag;
        end else begin
          while (length(partag)>0) and (partag[length(partag)]<>' ') do delete(partag,length(partag),1);
          delete(partag,length(partag),1);
        end;
        if tag='<mesto>' then setlength(mapa.mesta,length(mapa.mesta)+1);
        if tag='<cesta>' then setlength(mapa.cesty,length(mapa.cesty)+1);
        if tag='<spotreba>' then setlength(mapa.spotreby,length(mapa.spotreby)+1);
        if tag='</nazev>' then begin
          mapa.mesta[length(mapa.mesta)-1].nazev:=a;
          combobox1.Items.Add(a);
          combobox2.Items.Add(a);
        end;
        if tag='</polohaX>' then mapa.mesta[length(mapa.mesta)-1].poloha.x:=strtoint(a);
        if tag='</polohaY>' then mapa.mesta[length(mapa.mesta)-1].poloha.y:=strtoint(a);
        if tag='</z>' then mapa.cesty[length(mapa.cesty)-1].z:=a;
        if tag='</do>' then mapa.cesty[length(mapa.cesty)-1].doo:=a;
        if tag='</vzdalenost>' then begin
          if pos('.',a)>0 then a[pos('.',a)]:=decimalseparator;
          mapa.cesty[length(mapa.cesty)-1].vzdalenost:=strtofloat(a);
        end;
        if tag='</prumernaRychlost>' then begin
          if pos('.',a)>0 then a[pos('.',a)]:=decimalseparator;
          mapa.cesty[length(mapa.cesty)-1].prumernaRychlost:=strtofloat(a);
        end;
        if tag='</rychlost>' then begin
          if pos('.',a)>0 then a[pos('.',a)]:=decimalseparator;
          mapa.spotreby[length(mapa.spotreby)-1].rychlost:=strtofloat(a);
        end;
        if tag='</litru>' then begin
          if pos('.',a)>0 then a[pos('.',a)]:=decimalseparator;
          mapa.spotreby[length(mapa.spotreby)-1].litru:=strtofloat(a);
        end;
      end;
      for i:=0 to panel1.ControlCount-1 do panel1.Controls[i].Enabled:=true;
      closefile(t);
      draw;
    end else showmessage('Vybran soubor neexistuje!');
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  mapa.mesta:=nil;
  mapa.cesty:=nil;
  mapa.spotreby:=nil;
  application.Terminate;
end;


procedure TForm1.draw;         //vykresleni

var
i:integer;
minx,miny,maxx,maxy:integer;
px,py:real;
tmpces,mm:string;

function getPos(mesto:string):Tpoint;
var
i:integer;
begin
  for i:=0 to length(mapa.mesta)-1 do if mesto=mapa.mesta[i].nazev then begin
    result.x:=round((10+mapa.mesta[i].poloha.x-minx)*px);
    result.y:=round((10+mapa.mesta[i].poloha.y-miny)*py);
    exit;
  end;
end;


begin
  minx:=1000;
  maxx:=-1000;
  miny:=1000;
  maxy:=-1000;
  for i:=0 to length(mapa.mesta)-1 do begin
    if mapa.mesta[i].poloha.x<minx then minx:=mapa.mesta[i].poloha.x;
    if mapa.mesta[i].poloha.x>maxx then maxx:=mapa.mesta[i].poloha.x;
    if mapa.mesta[i].poloha.y<miny then miny:=mapa.mesta[i].poloha.y;
    if mapa.mesta[i].poloha.y>maxy then maxy:=mapa.mesta[i].poloha.y;
  end;
  px:=image1.Width/(maxx-minx+20);
  py:=image1.Height/(maxy-miny+20);
  image1.Picture:=nil;
  if opt.cesty then begin
    for i:=0 to length(mapa.cesty)-1 do begin
    if mapa.cesty[i].prumernaRychlost<80 then image1.Canvas.Pen.Color:=clred else
    if mapa.cesty[i].prumernaRychlost<100 then image1.Canvas.Pen.Color:=$000080FF else
    image1.Canvas.Pen.Color:=cllime;
    image1.Canvas.Polyline([getpos(mapa.cesty[i].z),getpos(mapa.cesty[i].doo)]);

    end;
  end;

  if length(ces)>0 then begin
    tmpces:=ces;
    image1.Canvas.MoveTo(-1,-1);
    while length(ces)>0 do begin
      if pos(';',ces)=0 then begin
        mm:=ces;
        ces:='';
      end else begin
        mm:=copy(ces,1,pos(';',ces)-1);
        delete(ces,1,pos(';',ces));
      end;
      image1.canvas.Pen.Color:=clblack;
      image1.canvas.Pen.Width:=2;
      for i:=0 to length(mapa.mesta)-1 do if mapa.mesta[i].nazev=mm then begin
        if (image1.Canvas.PenPos.x=-1) and (image1.Canvas.PenPos.y=-1) then image1.Canvas.MoveTo(index[i].x,index[i].Y) else
        image1.Canvas.LineTo(index[i].x,index[i].Y);
      end;
    end;
    for i:=0 to length(mapa.mesta)-1 do if mapa.mesta[i].nazev=combobox2.text then image1.Canvas.LineTo(index[i].x,index[i].Y);
    ces:=tmpces;
  end;
  image1.canvas.Pen.Width:=1;
  image1.Canvas.Pen.Color:=opt.c1;
  image1.Canvas.Brush.Color:=opt.c2;
  index:=nil;
  setlength(index,length(mapa.mesta));
  for i:=0 to length(mapa.mesta)-1 do begin
    image1.Canvas.Brush.Color:=opt.c2;
    image1.Canvas.Brush.Style:=bssolid;
    index[i].x:=round((10+mapa.mesta[i].poloha.X-minx)*px);
    index[i].y:=round((10+mapa.mesta[i].poloha.y-miny)*py);
    image1.canvas.Ellipse(rect(round((10+mapa.mesta[i].poloha.X-minx)*px)-opt.pol,round((10+mapa.mesta[i].poloha.y-miny)*py)-opt.pol,round((10+mapa.mesta[i].poloha.X-minx)*px)+opt.pol,round((10+mapa.mesta[i].poloha.y-miny)*py)+opt.pol));
//    :=point(round((10+mapa.mesta[i].poloha.X-minx)*px),round((10+mapa.mesta[i].poloha.y-miny)*py));
    if opt.nazvy then begin
      image1.Canvas.Brush.Style:=bsclear;
      image1.canvas.TextOut(round((10+mapa.mesta[i].poloha.X-minx)*px)-canvas.TextWidth(mapa.mesta[i].nazev) div 2,round((10+mapa.mesta[i].poloha.y-miny)*py)+opt.pol+1,mapa.mesta[i].nazev);
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  opt.pol:=3;
  opt.c1:=clblue;
  opt.c2:=$00FFE0C1;
  opt.nazvy:=false;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  opt.nazvy:=checkbox1.Checked;
  draw;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  draw;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  opt.cesty:=checkbox2.Checked;
  draw;
end;

function inrect(x,y,x1,y1,x2,y2:integer):boolean;
var
c:integer;
begin
  if x1>x2 then begin
    c:=x1;
    x1:=x2;
    x2:=c;
  end;
  if y1>y2 then begin
    c:=y1;
    y1:=y2;
    y2:=c;
  end;
  result:=(x>=x1) and (x<=x2) and (y>=y1) and (y<=y2);
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
i,j:integer;
begin
  for i:=0 to length(index)-1 do if inrect(index[i].x,index[i].y,x-opt.pol,y-opt.pol,x+opt.pol,y+opt.pol) then begin
    memo1.Lines.Clear;
    memo1.Lines.Add('Msto: '+mapa.mesta[i].nazev);
    for j:=0 to length(mapa.cesty)-1 do begin
      if mapa.cesty[j].z=mapa.mesta[i].nazev then begin
        memo1.Lines.Add('->'+mapa.cesty[j].doo);
        memo1.Lines.Add(format('vzdlenost: %.0f km',[mapa.cesty[j].vzdalenost]));
        memo1.Lines.Add(format('doba: %.1f h',[mapa.cesty[j].vzdalenost/mapa.cesty[j].prumernaRychlost]));
      end else
      if mapa.cesty[j].doo=mapa.mesta[i].nazev then begin
        memo1.Lines.Add('->'+mapa.cesty[j].z);
        memo1.Lines.Add(format('vzdlenost: %.0f km',[mapa.cesty[j].vzdalenost]));
        memo1.Lines.Add(format('doba: %.1f h',[mapa.cesty[j].vzdalenost/mapa.cesty[j].prumernaRychlost]));
      end;
    end;
    exit;
  end;
end;

procedure pathfinder1(cil,mesto,cesta:string;vzdalenost:real);
var
i,j:integer;
begin
  with form1 do begin
    for i:=0 to length(mapa.cesty)-1 do begin
      if length(fces)>0 then begin
        for j:=0 to length(fces)-1 do if fces[j].delka<vzdalenost then exit;
      end;
      if mesto=cil then begin
        setlength(fces,length(fces)+1);
        fces[length(fces)-1].cesta:=cesta;
        fces[length(fces)-1].delka:=vzdalenost;
        exit;
      end;
      if (mapa.cesty[i].z=mesto) and (pos(mapa.cesty[i].doo,cesta)=0) then pathfinder1(cil,mapa.cesty[i].doo,cesta+';'+mesto,vzdalenost+mapa.cesty[i].vzdalenost);
      if (mapa.cesty[i].doo=mesto) and (pos(mapa.cesty[i].z,cesta)=0) then pathfinder1(cil,mapa.cesty[i].z,cesta+';'+mesto,vzdalenost+mapa.cesty[i].vzdalenost);
    end;
  end;
end;

procedure pathfinder2(cil,mesto,cesta:string;vzdalenost:real);
var
i,j:integer;
begin
  with form1 do begin
    for i:=0 to length(mapa.cesty)-1 do begin
      if length(fces)>0 then begin
        for j:=0 to length(fces)-1 do if fces[j].delka<vzdalenost then exit;
      end;
      if mesto=cil then begin
        setlength(fces,length(fces)+1);
        fces[length(fces)-1].cesta:=cesta;
        fces[length(fces)-1].delka:=vzdalenost;
        exit;
      end;
      if (mapa.cesty[i].z=mesto) and (pos(mapa.cesty[i].doo,cesta)=0) then pathfinder2(cil,mapa.cesty[i].doo,cesta+';'+mesto,vzdalenost+mapa.cesty[i].prumernaRychlost/mapa.cesty[i].vzdalenost);
      if (mapa.cesty[i].doo=mesto) and (pos(mapa.cesty[i].z,cesta)=0) then pathfinder2(cil,mapa.cesty[i].z,cesta+';'+mesto,vzdalenost+mapa.cesty[i].prumernaRychlost/mapa.cesty[i].vzdalenost);
    end;
  end;
end;

procedure pathfinder3(cil,mesto,cesta:string;vzdalenost:real);
var
i,j:integer;
l:real;
begin
  with form1 do begin
    for i:=0 to length(mapa.cesty)-1 do begin
      if length(fces)>0 then begin
        for j:=0 to length(fces)-1 do if fces[j].delka<vzdalenost then exit;
      end;
      if mesto=cil then begin
        setlength(fces,length(fces)+1);
        fces[length(fces)-1].cesta:=cesta;
        fces[length(fces)-1].delka:=vzdalenost;
        exit;
      end;
      if (mapa.cesty[i].z=mesto) and (pos(mapa.cesty[i].doo,cesta)=0) then begin
        for j:=0 to length(mapa.spotreby)-1 do if mapa.spotreby[j].rychlost=mapa.cesty[i].prumernaRychlost then begin
          l:=mapa.spotreby[j].litru/100*mapa.cesty[i].vzdalenost;
          break;
        end;
        pathfinder3(cil,mapa.cesty[i].doo,cesta+';'+mesto,vzdalenost+l);
      end;
      if (mapa.cesty[i].doo=mesto) and (pos(mapa.cesty[i].z,cesta)=0) then begin
        for j:=0 to length(mapa.spotreby)-1 do if mapa.spotreby[j].rychlost=mapa.cesty[i].prumernaRychlost then begin
          l:=mapa.spotreby[j].litru/100*mapa.cesty[i].vzdalenost;
          break;
        end;
        pathfinder3(cil,mapa.cesty[i].z,cesta+';'+mesto,vzdalenost+l);
      end;
    end;
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
var
i,m:integer;
begin
  panel2.Left:=(width-panel2.Width) div 2;
  panel2.Top:=(Height-panel2.Height) div 2;
  panel2.Visible:=true;
  update;
  fces:=nil;
  case combobox3.ItemIndex of
    0:pathfinder1(combobox2.Text,combobox1.Text,'',0);
    1:pathfinder2(combobox2.Text,combobox1.Text,'',0);
    2:pathfinder3(combobox2.Text,combobox1.Text,'',0);
  end;
  m:=0;
  for i:=0 to length(fces)-1 do if (i=0) or (fces[m].delka>fces[i].delka) then m:=i;
  ces:=fces[m].cesta;
  delete(ces,1,1);
  memo2.Lines.Clear;
  case combobox3.ItemIndex of
    0:begin
       memo2.Lines.Add('Nejkrat cesta pro trasu '+combobox1.Text+'-'+combobox2.Text);
       memo2.Lines.Add(ces+';'+combobox2.Text);
       memo2.Lines.Add(format('Dlka cesty: %.0f km',[fces[m].delka]));
    end;
    1:begin
       memo2.Lines.Add('Nejrychlej cesta pro trasu '+combobox1.Text+'-'+combobox2.Text);
       memo2.Lines.Add(ces+';'+combobox2.Text);
       memo2.Lines.Add(format('Doba cesty: %.1f h',[fces[m].delka]));
    end;
    2:begin
       memo2.Lines.Add('Nejlevnj cesta pro trasu '+combobox1.Text+'-'+combobox2.Text);
       memo2.Lines.Add(ces+';'+combobox2.Text);
       memo2.Lines.Add(format('Spoteba benznu: %.1f l',[fces[m].delka]));
    end;
  end;
  fces:=nil;
  panel2.Visible:=false;
  draw;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ces:='';
  draw;
end;

procedure TForm1.Uloit1Click(Sender: TObject);
var
t:textfile;
rych,mm,tmpces:string;
i:integer;
begin
  if savedialog1.Execute then begin
    rych:='';
    assignfile(t,savedialog1.FileName);
    rewrite(t);
    writeln(t,'<?xml version="1.0" encoding="windows-1250" ?>');
    writeln(t,'<mapa>');
    writeln(t,'  <mesta>');
    if length(ces)>0 then begin
      tmpces:=ces;
      while length(ces)>0 do begin
        if pos(';',ces)=0 then begin
          mm:=ces;
          ces:='';
        end else begin
          mm:=copy(ces,1,pos(';',ces)-1);
          delete(ces,1,pos(';',ces));
        end;
        for i:=0 to length(mapa.mesta)-1 do if mapa.mesta[i].nazev=mm then begin
          writeln(t,'    <mesto>');
          writeln(t,'      <nazev>'+mapa.mesta[i].nazev+'</nazev>');
          writeln(t,'      <polohaX>'+inttostr(mapa.mesta[i].poloha.x)+'</polohaX>');
          writeln(t,'      <polohaY>'+inttostr(mapa.mesta[i].poloha.y)+'</polohaY>');
          writeln(t,'    </mesto>');
        end;
      end;
      for i:=0 to length(mapa.mesta)-1 do if mapa.mesta[i].nazev=combobox2.text then begin
        writeln(t,'    <mesto>');
        writeln(t,'      <nazev>'+mapa.mesta[i].nazev+'</nazev>');
        writeln(t,'      <polohaX>'+inttostr(mapa.mesta[i].poloha.x)+'</polohaX>');
        writeln(t,'      <polohaY>'+inttostr(mapa.mesta[i].poloha.y)+'</polohaY>');
        writeln(t,'    </mesto>');
      end;

      ces:=tmpces;
     end;
     writeln(t,'  </mesta>');
     writeln(t,'  <cesty>');
     tmpces:=tmpces+';'+combobox2.text;
     for i:=0 to length(mapa.cesty)-1 do if (pos(mapa.cesty[i].z,tmpces)>0) and (pos(mapa.cesty[i].doo,tmpces)>0) then begin
        writeln(t,'    <cesta>');
        writeln(t,'      <z>'+mapa.cesty[i].z+'</z>');
        writeln(t,'      <do>'+mapa.cesty[i].doo+'</do>');
        writeln(t,'      <vzdalenost>'+floattostr(mapa.cesty[i].vzdalenost)+'</vzdalenost>');
        writeln(t,'      <prumernaRychlost>'+floattostr(mapa.cesty[i].prumernaRychlost)+'</prumernaRychlost>');
        rych:=rych+';'+floattostr(mapa.cesty[i].prumernaRychlost);
        writeln(t,'    </cesta>');
     end;
     writeln(t,'  </cesty>');
     writeln(t,'  <spotreby>');
     for i:=0 to length(mapa.spotreby)-1 do begin
        writeln(t,'    <spotreba>');
        writeln(t,'      <rychlost>'+floattostr(mapa.spotreby[i].rychlost)+'</rychlost>');
        writeln(t,'      <litru>'+floattostr(mapa.spotreby[i].litru)+'</litru>');
        writeln(t,'    </spotreba>');
     end;
     writeln(t,'  </spotreby>');

     writeln(t,'</mapa>');
     closefile(t);
   end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
  var
  i:integer;
begin
  label12.Caption:='';
  for i:=0 to length(index)-1 do begin
    if inrect(index[i].x,index[i].y,x-opt.pol,y-opt.pol,x+opt.pol,y+opt.pol) then label12.Caption:=mapa.mesta[i].nazev;
  end;
end;

end.
